<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Discount3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Discount3 extends AbstractStructArrayBase
{
    /**
     * The ChildC
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Discount[]
     */
    public $ChildC;
    /**
     * Constructor method for ArrayOfJPSOAP_Discount3
     * @uses ArrayOfJPSOAP_Discount3::setChildC()
     * @param \StructType\JPSOAP_Discount[] $childC
     */
    public function __construct(array $childC = array())
    {
        $this
            ->setChildC($childC);
    }
    /**
     * Get ChildC value
     * @return \StructType\JPSOAP_Discount[]|null
     */
    public function getChildC()
    {
        return $this->ChildC;
    }
    /**
     * This method is responsible for validating the values passed to the setChildC method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildC method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildCForArrayConstraintsFromSetChildC(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_Discount3ChildCItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_Discount3ChildCItem instanceof \StructType\JPSOAP_Discount) {
                $invalidValues[] = is_object($arrayOfJPSOAP_Discount3ChildCItem) ? get_class($arrayOfJPSOAP_Discount3ChildCItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_Discount3ChildCItem), var_export($arrayOfJPSOAP_Discount3ChildCItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildC property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildC value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount[] $childC
     * @return \ArrayType\ArrayOfJPSOAP_Discount3
     */
    public function setChildC(array $childC = array())
    {
        // validation for constraint: array
        if ('' !== ($childCArrayErrorMessage = self::validateChildCForArrayConstraintsFromSetChildC($childC))) {
            throw new \InvalidArgumentException($childCArrayErrorMessage, __LINE__);
        }
        $this->ChildC = $childC;
        return $this;
    }
    /**
     * Add item to ChildC value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount $item
     * @return \ArrayType\ArrayOfJPSOAP_Discount3
     */
    public function addToChildC(\StructType\JPSOAP_Discount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Discount) {
            throw new \InvalidArgumentException(sprintf('The ChildC property can only contain items of type \StructType\JPSOAP_Discount, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildC[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Discount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Discount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildC
     */
    public function getAttributeName()
    {
        return 'ChildC';
    }
}
